100 CLS
110 FONT 2
120 LOCATE 20,0
130 PRINT "DUINOMITE - CANVIEW FOR PRIUS GEN2";
140 LOCATE 20,20
150 REM PRINT "CANPORT OPEN";
160 REM declare variables for message reception
170 DIM rxId : DIM rxType : DIM rxLen : DIM rxData(8) : DIM rxOk
180 REM set CAN baudrate to 500 kbps and connect to the CAN bus
190 CANOPEN 500000
200 REM start the program loop
210 DO
220 REM quit program when user pressed 'q'
230 IF INKEY$ = "q" THEN EXIT
240 REM check if a message was received
250 CANRCV rxId, rxType, rxLen, rxData(0), rxOk
260 IF rxOk = 1 THEN
270 REM process message data
290 REM PRINT VOLTAGE VALUE &H3B, BYTE 2.3
300 IF rxId = &H3B THEN Y = 65 : X = 360 : GOSUB 2000 : GOSUB 1080
310 FONT 2 : LOCATE 280,75 : PRINT "Volts:";
320 REM ************************************
330 REM PRINT THE AMPS VALUE &H3B, BYTE 0.1
340 IF rxId = &H3B THEN Y = 100 : X = 360 : GOSUB 2030 : GOSUB 1040
350 FONT 2 : LOCATE 293,110 : PRINT "Amps:";
360 REM ************************************
370 REM PRINT A-MAX VALUE &H3CB, BYTE 0
380 IF rxId = &H3CB THEN Y = 136 : X = 360 : GOSUB 1000
390 FONT 2 : LOCATE 280,146 : PRINT "A-MAX:";
400 REM ************************************
410 REM PRINT A+MAX VALUE &H3CB, BYTE 1 
420 IF rxId = &H3CB THEN Y = 172 : X = 360 : GOSUB 1040
430 FONT 2 : LOCATE 280,182 : PRINT "A+MAX:";
440 REM ************************************  
450 REM PRINT RPM VALUE &H3C8, BYTE 2
460 IF rxId = &H3C8 THEN Y = 212 : X = 360 : GOSUB 3000 : GOSUB 1080
470 FONT 2 : LOCATE 306,222 : PRINT "RPM:";
480 REM ************************************
490 REM PRINT TORQUE VALUE &H3C8, BYTE 3.4
500 IF rxId = &H3C8 THEN Y = 249 : X = 360 : GOSUB 2070 : GOSUB 1120
510 FONT 2 : LOCATE 319,258 : PRINT "NM:";
520 REM ************************************
530 REM PRINT SOC VALUE &H3CB, BYTE 3
540 IF rxId = &H3CB THEN Y = 286 : X = 360 : GOSUB 3030 : GOSUB 1120
550 FONT 2 : LOCATE 292,296 : PRINT "SOC%:";
560 REM ************************************
570 REM PRINT THROTTLE VALUE &H244, BYTE 6
580 IF rxId = &H244 THEN Y = 320 : X = 360 : GOSUB 3070 : GOSUB 1240
590 FONT 2 : LOCATE 266,330 : PRINT "THROT%:";
600 REM ************************************
610 REM PRINT ICE KW VALUE &H38, BYTE 1 
620 IF rxId = &H38 THEN Y = 356 : X = 360 : GOSUB 4020 : GOSUB 1040
630 FONT 2 : LOCATE 265,368 : PRINT "ICE KW:";
640 REM ************************************
650 REM PRINT BRAKE% VALUE &H30, BYTE 4 
660 IF rxId = &H30 THEN Y = 392 : X = 360 : GOSUB 1160
670 FONT 2 : LOCATE 264,400 : PRINT "BRAKE%:";
680 REM ************************************
780 IF rxId = &H3CD THEN Y = 260 : X = 120 : REM GOSUB 1000
790 IF rxId = &H3CF THEN Y = 280 : X = 120 :REM GOSUB 1000
800 IF rxId = &H484 THEN Y = 300 : X = 120 : REM GOSUB 1000
810 IF rxId = &H25 THEN Y = 320 : X = 120 : REM GOSUB 1000
820 IF rxId = &H540 THEN Y = 340 : X = 120 : REM GOSUB 1000
830 IF rxId = &H30 THEN Y = 360 : X = 120 : REM GOSUB 1000
840 IF rxId = &H230 THEN Y = 380 : X = 120 : REM GOSUB 1000
850 IF rxId = &hCB THEN Y = 400 : X = 120 : REM GOSUB 1000
930 ENDIF
940 LOOP
950 CANCLOSE
960 CLS
970 PRINT "            CANPORT CLOSED"
980 END
990 REM ********* SUBROUTINES ***********
1000 REM PRINT BYTE 0 : FONT 3
1010 LOCATE X,Y : FONT 3
1020 PRINT FORMAT$(rxData(0),"%+ g");
1030 RETURN
1040 REM PRINT BYTE 1 : FONT 3
1050 LOCATE X,Y : FONT 3
1060 PRINT FORMAT$(rxData(1),"%+ g");
1070 RETURN
1080 REM PRINT BYTE 2 : FONT 3
1090 LOCATE X,Y : FONT 3
1100 PRINT FORMAT$(rxData(2),"% g");
1110 RETURN
1120 REM PRINT BYTE 3 : FONT 3
1130 LOCATE X,Y : FONT 3
1140 PRINT FORMAT$(rxData(3),"% g");
1150 RETURN
1160 REM PRINT BYTE 4 : FONT 3
1170 LOCATE X,Y : FONT 3
1180 PRINT FORMAT$(rxData(4),"%+ g");
1190 RETURN
1200 REM PRINT BYTE 5 : FONT 3
1210 LOCATE X,Y : FONT 3
1220 PRINT FORMAT$(rxData(5),"%+ g");
1230 RETURN
1240 REM PRINT BYTE 6 : FONT 3
1250 LOCATE X,Y : FONT 3
1260 PRINT FORMAT$(rxData(6),"% g");
1270 RETURN
1280 REM PRINT BYTE 7 : FONT 3
1290 LOCATE X,Y : FONT 3
1300 PRINT FORMAT$(rxData(7),"%+ g");
1310 RETURN
1990 REM ************************************
2000 REM TWO BYTE DATA, BYTE 2.3
2010 rxData(2) = rxData(2) * 256 + rxData(3) 
2020 RETURN
2025 REM ************************************
2030 REM TWO BYTE DATA, BYTE 0.1 SIGNED
2040 rxData(1) = (rxData(1)/10) : REM TWO BYTE DATA SIGNED
2050 IF rxData(0) = &H0 THEN rxdata(1) = rxData(1) * -1
2060 RETURN
2065 REM ************************************
2070 REM TWO BYTE DATA, BYTE 3.4
2080 rxData(3) = rxData(3) * 256 + rxData(4)
2090 RETURN
2093 REM ************************************
3000 REM BYTE DATA, BYTE 2 * (32REV/min)
3010 rxData(2) = rxData(2) * 32 : REM BYTE 2 DATA * (32REV/min)
3020 RETURN
3030 REM ************************************
3040 REM BYTE DATA, BYTE 3 / 2
3050 rxData(3) = rxData(3) / 2 : REM BYTE 3 DATA / 2 
3060 RETURN
3070 REM ************************************
3080 REM BYTE DATA, BYTE 6 / 2
3090 rxData(6) = rxData(6) / 2 : REM BYTE 6 DATA / 2 
4000 RETURN
4010 REM ************************************
4020 REM BYTE DATA, BYTE 1 * 0.25
4030 rxData(1) = rxData(1) * 0.25 : REM BYTE 1 DATA * 0.25 
4040 RETURN
